import React, { FC } from 'react'
import innerText from 'react-innertext'
import { hasPrivilege } from './PermissionsManager'
import { isEmpty } from 'sunny-js/util/index'

interface PrivilegeProps {
  // 资源名称，一般不用传递，如果默认值location.pathname无法满足，请传入
  resource?: string,
  // 特权键名，通常是由 {@link ModuleInterfaces.privilegeProp} 决定的
  k?: string
}
export const Privilege: FC<PrivilegeProps> = ({
  k,
  resource,
  children
}) => <>{
  hasPrivilege(
    isEmpty(k)
      // 尝试自动获取文本作为key
      ? innerText(children).trim()
      : k,
    resource
  )
    ? children
    : null
}</>
