import {
  createImplement,
  invokeInterface,
  shouldImplement
} from 'sunny-js/util/module'
import { RouteProps } from 'react-router'
interface ModuleInterfaces {
  // 验证是否登录
  authenticate?: () => Promise<any>,
  // 转向登录
  forwardToLogin?: (err?) => void
  // 访问控制
  access?: (routeProps: RouteProps) => Promise<any>
  // 拒绝访问
  blockVisitor?: (err?) => void
}
const iAuth = {} as ModuleInterfaces
export const implement = createImplement(iAuth)

// 登录认证
export const authenticate = invokeInterface(
  () => iAuth.authenticate,
  () => Promise.resolve()
)
// 跳转到登录
export const forwardToLogin = invokeInterface(
  () => iAuth.forwardToLogin,
  () => shouldImplement('iAuth.forwardToLogin')
)

// 访问控制
export const access = invokeInterface(
  () => iAuth.access,
  () => Promise.resolve()
)
// 阻止访问
export const blockVisitor = invokeInterface(
  () => iAuth.blockVisitor,
  () => iAuth.access && shouldImplement('iAuth.blockVisitor')
)
